/*
 * Copyright (C) 2015 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package org.thema.pixscape.tools;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.io.IOException;
import javax.swing.AbstractAction;
import javax.swing.ActionMap;
import javax.swing.InputMap;
import javax.swing.JComponent;
import javax.swing.KeyStroke;
import org.thema.pixscape.Project;
import org.thema.pixscape.view.cuda.ComputeViewCUDA;

/**
 * Dialog form for setting global options :
 * eye height, angular precision, earth curvature, refraction, multi scale mode, GPU
 * 
 * @author Gilles Vuidel
 */
public class OptionDialog extends javax.swing.JDialog {

    private final Project project;
    
    /** 
     * Creates new form OptionDialog
     * @param parent the parent frame
     * @param project the current project
     */
    public OptionDialog(Frame parent, Project project) {
        super(parent, true);
        this.project = project;
        initComponents();
        setLocationRelativeTo(parent);
        getRootPane().setDefaultButton(okButton);
        // Close the dialog when Esc is pressed
        String cancelName = "cancel";
        InputMap inputMap = getRootPane().getInputMap(JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
        inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), cancelName);
        ActionMap actionMap = getRootPane().getActionMap();
        actionMap.put(cancelName, new AbstractAction() {
            @Override
            public void actionPerformed(ActionEvent e) {
                doClose();
            }
        });
        
        multiScaleCheckBox.setEnabled(project.hasMultiScale());
        zEyeTextField.setText(""+project.getStartZ());
        aPrecjTextField.setText(""+project.getAlphaPrec());
        earthCurvCheckBox.setSelected(project.isEarthCurv());
        coefRefracTextField.setText(""+project.getCoefRefraction());
        multiScaleCheckBox.setEnabled(project.hasMultiScale());
        multiScaleCheckBox.setSelected(project.isMSComputation());
        minDistTextField.setText(""+project.getMinDistMS());
        gpuCheckBox.setSelected(project.isUseCUDA());
        
        if(!ComputeViewCUDA.isCUDAAvailable()) {
            gpuCheckBox.setSelected(false);
            gpuCheckBox.setEnabled(false);
        }
    }


    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        zEyeTextField = new javax.swing.JTextField();
        multiScaleCheckBox = new javax.swing.JCheckBox();
        minDistTextField = new javax.swing.JTextField();
        gpuCheckBox = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        aPrecjTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        earthCurvCheckBox = new javax.swing.JCheckBox();
        coefRefracTextField = new javax.swing.JTextField();
        coefRefracLabel = new javax.swing.JLabel();

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle"); // NOI18N
        setTitle(bundle.getString("OptionDialog.title")); // NOI18N
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        java.util.ResourceBundle bundle1 = java.util.ResourceBundle.getBundle("org/thema/pixscape/tools/Bundle"); // NOI18N
        okButton.setText(bundle1.getString("OptionDialog.okButton.text")); // NOI18N
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText(bundle1.getString("OptionDialog.cancelButton.text")); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jLabel2.setText(bundle1.getString("OptionDialog.jLabel2.text")); // NOI18N

        zEyeTextField.setText(bundle1.getString("OptionDialog.zEyeTextField.text")); // NOI18N

        multiScaleCheckBox.setText(bundle1.getString("OptionDialog.multiScaleCheckBox.text")); // NOI18N
        multiScaleCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                multiScaleCheckBoxActionPerformed(evt);
            }
        });

        minDistTextField.setText(bundle1.getString("OptionDialog.minDistTextField.text")); // NOI18N

        gpuCheckBox.setText(bundle1.getString("OptionDialog.gpuCheckBox.text")); // NOI18N

        jLabel1.setText(bundle1.getString("OptionDialog.jLabel1.text")); // NOI18N

        aPrecjTextField.setText(bundle1.getString("OptionDialog.aPrecjTextField.text")); // NOI18N

        jLabel3.setText(bundle1.getString("OptionDialog.jLabel3.text")); // NOI18N

        earthCurvCheckBox.setText(bundle1.getString("OptionDialog.earthCurvCheckBox.text")); // NOI18N
        earthCurvCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                earthCurvCheckBoxActionPerformed(evt);
            }
        });

        coefRefracTextField.setText(bundle1.getString("OptionDialog.coefRefracTextField.text")); // NOI18N

        coefRefracLabel.setText(bundle1.getString("OptionDialog.coefRefracLabel.text")); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(cancelButton))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addGap(18, 18, 18)
                                .addComponent(zEyeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(gpuCheckBox)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(multiScaleCheckBox)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(minDistTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(aPrecjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 95, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(3, 3, 3)
                                .addComponent(jLabel3))
                            .addComponent(earthCurvCheckBox)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(12, 12, 12)
                                .addComponent(coefRefracLabel)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(coefRefracTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 56, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(0, 1, Short.MAX_VALUE)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {cancelButton, okButton});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(zEyeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(aPrecjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3))
                .addGap(18, 18, 18)
                .addComponent(earthCurvCheckBox)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(coefRefracTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(coefRefracLabel))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(multiScaleCheckBox)
                    .addComponent(minDistTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(gpuCheckBox)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cancelButton)
                    .addComponent(okButton))
                .addContainerGap())
        );

        getRootPane().setDefaultButton(okButton);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        project.setStartZ(Double.parseDouble(zEyeTextField.getText()));
        project.setAlphaPrec(Double.parseDouble(aPrecjTextField.getText()));
        project.setEarthCurv(earthCurvCheckBox.isSelected());
        if(earthCurvCheckBox.isSelected()) {
            project.setCoefRefraction(Double.parseDouble(coefRefracTextField.getText()));
        } else {
            project.setCoefRefraction(0.0);
        }
        if(multiScaleCheckBox.isSelected()) {
            project.setMinDistMS(Double.parseDouble(minDistTextField.getText()));
        } else {
            project.setMinDistMS(0);
        }
        project.setUseCUDA(gpuCheckBox.isSelected() ? 1 : 0);
        try {
            project.save();
        } catch (IOException ex) {
            throw new RuntimeException(ex);
        }
        doClose();
    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        doClose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        doClose();
    }//GEN-LAST:event_closeDialog

    private void multiScaleCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_multiScaleCheckBoxActionPerformed
        minDistTextField.setEnabled(multiScaleCheckBox.isSelected());
    }//GEN-LAST:event_multiScaleCheckBoxActionPerformed

    private void earthCurvCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_earthCurvCheckBoxActionPerformed
        coefRefracLabel.setEnabled(earthCurvCheckBox.isSelected());
        coefRefracTextField.setEnabled(earthCurvCheckBox.isSelected());
    }//GEN-LAST:event_earthCurvCheckBoxActionPerformed

    
    private void doClose() {
        setVisible(false);
        dispose();
    }

   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField aPrecjTextField;
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel coefRefracLabel;
    private javax.swing.JTextField coefRefracTextField;
    private javax.swing.JCheckBox earthCurvCheckBox;
    private javax.swing.JCheckBox gpuCheckBox;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JTextField minDistTextField;
    private javax.swing.JCheckBox multiScaleCheckBox;
    private javax.swing.JButton okButton;
    private javax.swing.JTextField zEyeTextField;
    // End of variables declaration//GEN-END:variables

}
